<html>
<head>
<title>OgreGLSupport.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSupport.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSupport_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef OGRE_GLSUPPORT_H</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define OGRE_GLSUPPORT_H</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLRenderSystem_8h.html">OgreGLRenderSystem.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderWindow_8h.html">OgreRenderWindow.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreConfigOptionMap_8h.html">OgreConfigOptionMap.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPBuffer_8h.html">OgreGLPBuffer.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040     
<a name="l00041"></a><a class="code" href="classOgre_1_1GLSupport.html">00041</a> <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 <span class="keyword">public</span>:
<a name="l00044"></a><a class="code" href="classOgre_1_1GLSupport.html#a6f9ba5ca177845957a42cd1bd95f1c92">00044</a>     <a class="code" href="classOgre_1_1GLSupport.html#a6f9ba5ca177845957a42cd1bd95f1c92">GLSupport</a>() { }
<a name="l00045"></a><a class="code" href="classOgre_1_1GLSupport.html#a6da70cbba51979f3b3360cd4fc412f75">00045</a>     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GLSupport.html#a6da70cbba51979f3b3360cd4fc412f75">~GLSupport</a>() { }
<a name="l00046"></a>00046 
<a name="l00052"></a>00052     <span class="keyword">virtual</span> <span class="keywordtype">void</span> addConfig() = 0;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054     <span class="keyword">virtual</span> <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value);
<a name="l00055"></a>00055 
<a name="l00060"></a>00060     <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfig() = 0;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="keyword">virtual</span> <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a>&amp; getConfigOptions(<span class="keywordtype">void</span>);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* createWindow(<span class="keywordtype">bool</span> autoCreateWindow, <a class="code" href="classOgre_1_1GLRenderSystem.html" title="Implementation of GL as a rendering system.">GLRenderSystem</a>* renderSystem, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle) = 0;
<a name="l00065"></a>00065 
<a name="l00067"></a>00067     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* newWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00068"></a>00068         <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0) = 0;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> supportsPBuffers();
<a name="l00071"></a>00071     <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1GLPBuffer.html" title="An off-screen rendering context.">GLPBuffer</a> *createPBuffer(<a class="code" href="group__Image.html#gac8f59c884998d9f84d9ea4c66e4c29fe" title="Pixel component format.">PixelComponentType</a> format, <span class="keywordtype">size_t</span> width, <span class="keywordtype">size_t</span> height);
<a name="l00072"></a>00072 
<a name="l00076"></a>00076     <span class="keyword">virtual</span> <span class="keywordtype">void</span> start() = 0;
<a name="l00080"></a>00080     <span class="keyword">virtual</span> <span class="keywordtype">void</span> stop() = 0;
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classOgre_1_1GLSupport.html#a605553feadb63b0b40e25cda379a21d8">00085</a>     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getGLVendor(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00086"></a>00086 <span class="keyword">    </span>{
<a name="l00087"></a>00087         <span class="keywordflow">return</span> mVendor;
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classOgre_1_1GLSupport.html#abfca0d98cde4f5bed7f805adac5adc72">00093</a>     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getGLVersion(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00094"></a>00094 <span class="keyword">    </span>{
<a name="l00095"></a>00095         <span class="keywordflow">return</span> mVersion;
<a name="l00096"></a>00096     }
<a name="l00097"></a>00097 
<a name="l00101"></a>00101     <span class="keywordtype">bool</span> checkMinGLVersion(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; v) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00106"></a>00106     <span class="keyword">virtual</span> <span class="keywordtype">bool</span> checkExtension(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; ext) <span class="keyword">const</span>;
<a name="l00110"></a>00110     <span class="keyword">virtual</span> <span class="keywordtype">void</span>* getProcAddress(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; procname) = 0;
<a name="l00111"></a>00111 
<a name="l00115"></a>00115     <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialiseExtensions();
<a name="l00116"></a>00116 
<a name="l00118"></a><a class="code" href="classOgre_1_1GLSupport.html#a379f629aae4ba8ea96943936df5c31ab">00118</a>     <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDisplayMonitorCount()<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword">    </span>{
<a name="l00120"></a>00120         <span class="keywordflow">return</span> 1;
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="keyword">protected</span>:
<a name="l00124"></a>00124     <span class="comment">// Stored options</span>
<a name="l00125"></a><a class="code" href="classOgre_1_1GLSupport.html#a5b5c4f15e6fee184e059f11790cb30b5">00125</a>     <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a> <a class="code" href="classOgre_1_1GLSupport.html#a5b5c4f15e6fee184e059f11790cb30b5">mOptions</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     <span class="comment">// This contains the complete list of supported extensions</span>
<a name="l00128"></a><a class="code" href="classOgre_1_1GLSupport.html#a0f3a8ac4a209aea9ef22b5aa4a40fcd7">00128</a>     <a class="code" href="structOgre_1_1set.html">set&lt;String&gt;::type</a> <a class="code" href="classOgre_1_1GLSupport.html#a0f3a8ac4a209aea9ef22b5aa4a40fcd7">extensionList</a>;
<a name="l00129"></a>00129 <span class="keyword">private</span>:
<a name="l00130"></a><a class="code" href="classOgre_1_1GLSupport.html#a83e842aa5b8fd36a7d9b94820ab8be5e">00130</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSupport.html#a83e842aa5b8fd36a7d9b94820ab8be5e">mVersion</a>;
<a name="l00131"></a><a class="code" href="classOgre_1_1GLSupport.html#a69e070222ab7665286cd951134313724">00131</a>     <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1GLSupport.html#a69e070222ab7665286cd951134313724">mVendor</a>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 }; <span class="comment">// class GLSupport</span>
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 } <span class="comment">// namespace Ogre</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#endif // OGRE_GLSUPPORT_H</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
